C
C Copyright (c) Erik Lindahl, David van der Spoel 2003
C This file is generated automatically at compile time
C by the program mknb in the Gromacs distribution.
C
C Options used for generating this file:
C Language:         Take a wild guess
C Precision:        double
C Threads:          no
C Software invsqrt: yes
C PowerPC invsqrt:  no
C Prefetch forces:  no
C Comments:         no




C
C Gromacs nonbonded kernel nb_kernel010
C Coulomb interaction:     Not calculated
C VdW interaction:         Lennard-Jones
C water optimization:      No
C Calculate forces:        yes
C
      subroutine nb_kernel010(
     &                          nri,
     &                          iinr,
     &                          jindex,
     &                          jjnr,
     &                          shift,
     &                          shiftvec,
     &                          fshift,
     &                          gid,
     &                          pos,
     &                          faction,
     &                          charge,
     &                          facel,
     &                          krf,
     &                          crf,
     &                          Vc,
     &                          type,
     &                          ntype,
     &                          vdwparam,
     &                          Vvdw,
     &                          tabscale,
     &                          VFtab,
     &                          invsqrta,
     &                          dvda,
     &                          gbtabscale,
     &                          GBtab,
     &                          nthreads,
     &                          count,
     &                          mtx,
     &                          outeriter,
     &                          inneriter,
     &                          work)
      implicit      none
      integer*4     nri,iinr(*),jindex(*),jjnr(*),shift(*)
      real*8        shiftvec(*),fshift(*),pos(*),faction(*)
      integer*4     gid(*),type(*),ntype
      real*8        charge(*),facel,krf,crf,Vc(*),vdwparam(*)
      real*8        Vvdw(*),tabscale,VFtab(*)
      real*8        invsqrta(*),dvda(*),gbtabscale,GBtab(*)
      integer*4     nthreads,count,mtx,outeriter,inneriter
      real*8        work(*)

      integer*4     n,ii,is3,ii3,k,nj0,nj1,jnr,j3,ggid
      real*8        shX,shY,shZ
      real*8        fscal,tx,ty,tz
      real*8        rinvsq
      integer*4     nti
      integer*4     tj
      real*8        rinvsix
      real*8        Vvdw6,Vvdwtot
      real*8        Vvdw12
      real*8        ix1,iy1,iz1,fix1,fiy1,fiz1
      real*8        jx1,jy1,jz1
      real*8        dx11,dy11,dz11,rsq11
      real*8        c6,c12

      nj1              = 0               
      
      do n=1,nri
        is3              = 3*shift(n)+1    
        shX              = shiftvec(is3)   
        shY              = shiftvec(is3+1) 
        shZ              = shiftvec(is3+2) 
        nj0              = jindex(n)+1     
        nj1              = jindex(n+1)     
        ii               = iinr(n)+1       
        ii3              = 3*ii-2          
        ix1              = shX + pos(ii3+0)
        iy1              = shY + pos(ii3+1)
        iz1              = shZ + pos(ii3+2)
        nti              = 2*ntype*type(ii)
        Vvdwtot          = 0               
        fix1             = 0               
        fiy1             = 0               
        fiz1             = 0               
        
        do k=nj0,nj1
          jnr              = jjnr(k)+1       
          j3               = 3*jnr-2         
          jx1              = pos(j3+0)       
          jy1              = pos(j3+1)       
          jz1              = pos(j3+2)       
          dx11             = ix1 - jx1       
          dy11             = iy1 - jy1       
          dz11             = iz1 - jz1       
          rsq11            = dx11*dx11+dy11*dy11+dz11*dz11
          rinvsq           = 1.0/rsq11       
          tj               = nti+2*type(jnr)+1
          c6               = vdwparam(tj)    
          c12              = vdwparam(tj+1)  
          rinvsix          = rinvsq*rinvsq*rinvsq
          Vvdw6            = c6*rinvsix      
          Vvdw12           = c12*rinvsix*rinvsix
          Vvdwtot          = Vvdwtot+Vvdw12-Vvdw6
          fscal            = (12.0*Vvdw12-6.0*Vvdw6)*rinvsq
          tx               = fscal*dx11      
          ty               = fscal*dy11      
          tz               = fscal*dz11      
          fix1             = fix1 + tx       
          fiy1             = fiy1 + ty       
          fiz1             = fiz1 + tz       
          faction(j3+0)    = faction(j3+0) - tx
          faction(j3+1)    = faction(j3+1) - ty
          faction(j3+2)    = faction(j3+2) - tz
        end do
        
        faction(ii3+0)   = faction(ii3+0) + fix1
        faction(ii3+1)   = faction(ii3+1) + fiy1
        faction(ii3+2)   = faction(ii3+2) + fiz1
        fshift(is3)      = fshift(is3)+fix1
        fshift(is3+1)    = fshift(is3+1)+fiy1
        fshift(is3+2)    = fshift(is3+2)+fiz1
        ggid             = gid(n)+1        
        Vvdw(ggid)       = Vvdw(ggid) + Vvdwtot
      end do
      
      outeriter        = nri             
      inneriter        = nj1             
      return
      end






C
C Gromacs nonbonded kernel nb_kernel010nf
C Coulomb interaction:     Not calculated
C VdW interaction:         Lennard-Jones
C water optimization:      No
C Calculate forces:        no
C
      subroutine nb_kernel010nf(
     &                          nri,
     &                          iinr,
     &                          jindex,
     &                          jjnr,
     &                          shift,
     &                          shiftvec,
     &                          fshift,
     &                          gid,
     &                          pos,
     &                          faction,
     &                          charge,
     &                          facel,
     &                          krf,
     &                          crf,
     &                          Vc,
     &                          type,
     &                          ntype,
     &                          vdwparam,
     &                          Vvdw,
     &                          tabscale,
     &                          VFtab,
     &                          invsqrta,
     &                          dvda,
     &                          gbtabscale,
     &                          GBtab,
     &                          nthreads,
     &                          count,
     &                          mtx,
     &                          outeriter,
     &                          inneriter,
     &                          work)
      implicit      none
      integer*4     nri,iinr(*),jindex(*),jjnr(*),shift(*)
      real*8        shiftvec(*),fshift(*),pos(*),faction(*)
      integer*4     gid(*),type(*),ntype
      real*8        charge(*),facel,krf,crf,Vc(*),vdwparam(*)
      real*8        Vvdw(*),tabscale,VFtab(*)
      real*8        invsqrta(*),dvda(*),gbtabscale,GBtab(*)
      integer*4     nthreads,count,mtx,outeriter,inneriter
      real*8        work(*)

      integer*4     n,ii,is3,ii3,k,nj0,nj1,jnr,j3,ggid
      real*8        shX,shY,shZ
      real*8        rinvsq
      integer*4     nti
      integer*4     tj
      real*8        rinvsix
      real*8        Vvdw6,Vvdwtot
      real*8        Vvdw12
      real*8        ix1,iy1,iz1
      real*8        jx1,jy1,jz1
      real*8        dx11,dy11,dz11,rsq11
      real*8        c6,c12

      nj1              = 0               
      
      do n=1,nri
        is3              = 3*shift(n)+1    
        shX              = shiftvec(is3)   
        shY              = shiftvec(is3+1) 
        shZ              = shiftvec(is3+2) 
        nj0              = jindex(n)+1     
        nj1              = jindex(n+1)     
        ii               = iinr(n)+1       
        ii3              = 3*ii-2          
        ix1              = shX + pos(ii3+0)
        iy1              = shY + pos(ii3+1)
        iz1              = shZ + pos(ii3+2)
        nti              = 2*ntype*type(ii)
        Vvdwtot          = 0               
        
        do k=nj0,nj1
          jnr              = jjnr(k)+1       
          j3               = 3*jnr-2         
          jx1              = pos(j3+0)       
          jy1              = pos(j3+1)       
          jz1              = pos(j3+2)       
          dx11             = ix1 - jx1       
          dy11             = iy1 - jy1       
          dz11             = iz1 - jz1       
          rsq11            = dx11*dx11+dy11*dy11+dz11*dz11
          rinvsq           = 1.0/rsq11       
          tj               = nti+2*type(jnr)+1
          c6               = vdwparam(tj)    
          c12              = vdwparam(tj+1)  
          rinvsix          = rinvsq*rinvsq*rinvsq
          Vvdw6            = c6*rinvsix      
          Vvdw12           = c12*rinvsix*rinvsix
          Vvdwtot          = Vvdwtot+Vvdw12-Vvdw6
        end do
        
        ggid             = gid(n)+1        
        Vvdw(ggid)       = Vvdw(ggid) + Vvdwtot
      end do
      
      outeriter        = nri             
      inneriter        = nj1             
      return
      end



